package webapps.ajax1.model;

import java.sql.*;
import java.util.*;
import org.firebirdsql.jdbc.*;

/**
 * Coleccion de conexiones a b.d. firebird
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class FBCon {
    private org.firebirdsql.pool.FBWrappingDataSource ds = new org.firebirdsql.pool.FBWrappingDataSource();
    private Connection c = null;
    private static List<FBCon> lst = new ArrayList<FBCon>();
    
    /**
     * Constructor for objects of class FBCon
     */
    public FBCon(String db,String user,String pwd,String rol)
    {
        // me conecto a fb!
        try {
            
            System.out.println("JsonTestServlet: Me conecto!");
            // Set the standard properties
            ds.setDatabase(db);
            ds.setRoleName(rol);
            ds.setLoginTimeout(10);
            c = ds.getConnection(user,pwd);

            System.out.println ("Connection established.");
            c.setAutoCommit(false);
            System.out.println("Auto-commit is disabled.");
            
            lst.add(this);
            
        } catch(java.sql.SQLException e) {
            System.err.println("Error sql: "+e.getMessage());
        }
        
    }
    
    public Connection getConnection() {
        return c;
    }
    public static FBCon getFBCon(int n) {
        FBCon f = lst.get(n);
        if ( f != null ) return f;
        else return null;
    }
    public static Connection getConnection(int n) {
        FBCon f = lst.get(n);
        if ( f != null ) return f.getConnection();
        else return null;
    }
    public ResultSet getResultSet(final String query) throws SQLException {
        Statement ss = getConnection().createStatement();
        ResultSet rs = ss.executeQuery(query);
        return rs;
    }
    public int executeQuery(final String query) throws SQLException {
        return executeQuery(getConnection().createStatement(),query);
    }
    public int executeQuery(Statement st,final String query) throws SQLException {
        int n = st.executeUpdate(query);
        getConnection().commit();
        return n;
    }
    public void close(Statement ss) {
        try {
            ss.close();
        } catch(java.sql.SQLException e) {
            System.err.println("FBCon.close(Statement): Error sql: "+e.getMessage());
        }
    }
    public void close(ResultSet rs) {
        try {
            Statement ss = rs.getStatement();
            rs.close();
            ss.close();
        } catch(java.sql.SQLException e) {
            System.err.println("FBCon.close(ResultSet): Error sql: "+e.getMessage());
        }
    }
   
    public void close() {
        try {
            c.close();
            ds.shutdown();
        } catch(java.sql.SQLException e) {
            System.err.println("close(): Error sql: "+e.getMessage());
        }
    }
    public static void closeAll() {
        for(FBCon f : lst) f.close();
    }
}
